//+------------------------------------------------------------------+
//|                                                      ExtData.mq4 |
//|                                                             Gosh |
//|                                                  gosh_a@inbox.ru |
//+------------------------------------------------------------------+
#property copyright "Gosh"
#property link      "gosh_a@inbox.ru"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 MediumSpringGreen
#property indicator_color5 Magenta
#property indicator_color6 Silver
#property indicator_color7 Gold
#property indicator_color8 Brown

//---- input parameters
extern bool Show_USD=true;
extern bool Show_EUR=true;
extern bool Show_GBP=true;
extern bool Show_AUD=true;
extern bool Show_NZD=true;
extern bool Show_CHF=true;
extern bool Show_JPY=true;
extern bool Show_CAD=true;

//---- buffers
double USD[];
double EUR[];
double GBP[];
double AUD[];
double NZD[];
double CHF[];
double JPY[];
double CAD[];

string CS[8]={"USD","EUR","GBP","AUD","NZD","CHF","JPY","CAD"};
string FNRS[8]={"USD_DISC_RATE.csv","EUR_REF_TENDER.csv","GBP_REPO_RATE.csv",
                "AUD_CASH_RATE.csv","NZD_CASH_RATE.csv","CHF_3M_LIB_MAX.csv",
                "JPY_DISC_RATE.csv","CAD_BANK_RATE.csv"};
double RateS[8][1000][2];
double CurRate[8];
int    NRates[8];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int i,j,fh;
  string U,L;
//---- indicators
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,USD);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,EUR);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,GBP);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,AUD);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,NZD);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,CHF);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,JPY);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,CAD);
   U=StringSubstr(Symbol(),0,3);
   L=StringSubstr(Symbol(),3,3);
   for(i=0;i<=7;i++)
      {
      if(U==CS[i]) SetIndexStyle(i,DRAW_LINE,0,3);
      if(L==CS[i]) SetIndexStyle(i,DRAW_LINE,0,3);
      }
   IndicatorShortName("RatesAll");
   for(i=0;i<8;i++) 
      {
      SetIndexLabel(i,CS[i]);
      fh=FileOpen(FNRS[i],FILE_READ|FILE_CSV,';');
      if(fh==-1) Print("File ",FNRS[i]," open error");
      else Print("File ",FNRS[i]," processing...");
      j=0;
      while(!FileIsEnding(fh) )
         {
         string dates=FileReadString(fh);
         if(FileIsEnding(fh)) break;
         string times=FileReadString(fh);
         string datas=FileReadString(fh);
         RateS[i][j][0]=StrToTime(dates+" "+times);
         RateS[i][j][1]=StrToDouble(datas);
         j++;
         }
      NRates[i]=j;
      Print(NRates[i]," records found.");
      FileClose(fh);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,j,pos,counted_bars=IndicatorCounted();
//----
   if(counted_bars>0) counted_bars--;
   datetime pos_time;
   int limit=Bars-counted_bars;
   for(pos=0; pos<=limit; pos++)
      {
      pos_time=Time[pos];
      for(i=0;i<8;i++)
         {
         if(pos_time<=RateS[i][0][0]) {CurRate[i]=RateS[i][0][1];continue;}
         if(pos_time>=RateS[i][NRates[i]-1][0]) {CurRate[i]=RateS[i][NRates[i]-1][1];continue;} 
         j=0;
         while(pos_time>=RateS[i][j][0])j++;
         if(Period()>0)j--;
         CurRate[i]=RateS[i][j][1];
         }
//      Print("pos ",pos," RateUSD=",CurRate[0]);
      if(Show_USD) USD[pos]=CurRate[0]; else USD[pos]=EMPTY_VALUE;
      if(Show_EUR) EUR[pos]=CurRate[1]; else EUR[pos]=EMPTY_VALUE;
      if(Show_GBP) GBP[pos]=CurRate[2]; else GBP[pos]=EMPTY_VALUE;
      if(Show_AUD) AUD[pos]=CurRate[3]; else AUD[pos]=EMPTY_VALUE;
      if(Show_NZD) NZD[pos]=CurRate[4]; else NZD[pos]=EMPTY_VALUE;
      if(Show_CHF) CHF[pos]=CurRate[5]; else CHF[pos]=EMPTY_VALUE;
      if(Show_JPY) JPY[pos]=CurRate[6]; else JPY[pos]=EMPTY_VALUE;
      if(Show_CAD) CAD[pos]=CurRate[7]; else CAD[pos]=EMPTY_VALUE;
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+